Suiterec(L):={
local F,f,B;
local j,dx,nbp,P;
local xmin,xmax,ymin,ymax,ux,uy,cx,cy,gx,gy;
local textp,ip,etatc,val;
local T,N,V,textt;
local t,a,b,xtmin,xtmax,dt,tmin,tmax,df;
local li,g,sol,texts;
local texta,Q,texti;
local Su,Nb;
local textu,ui,uf,vi,vf,inds;

Su:=L[0];
V:=L[1];

F:=L[2];

xmin:=L[3];
xmax:=L[4];
ymin:=L[5];
ymax:=L[6];

ux:=L[7];
uy:=L[8];
cx:=L[9];
cy:=L[10];
gx:=L[11];
gy:=L[12];

T:=L[13];

f:=unapply(F[0],x);

if (size(F)==3) then
{
  B:=F[2];
  xtmin:=max(xmin,B[0]);
  xtmax:=min(xmax,B[1]);
}
else
{
  xtmin:=xmin;
  xtmax:=xmax;
}

nbp:=200;
dx:=evalf((xtmax-xtmin)/nbp);
P:=makemat(0,1,nbp+1);


etatc:=0;
nbc:=0;
textp:=("");

for (j:=0;j<=nbp;j++)
{
  x:=evalf(xtmin+j*dx);
  if (abs(x)<0.00001) then
  {
    x:=0;
  }
  val:=f(x);
  if (abs(val)<0.00001) then
  {
    val:=0;
  }
  if ((val>ymin-5) and (val<ymax+5)and (val!=infinity) and (im(val)==0))
  {
    if (etatc==0) then
    {
      etatc:=1;
      nbc:=nbc+1;
      ip:=1;
      P[0]:=[x,val];
      textp:=concat(textp,"P[1]:=("+evalf(x)+","+evalf(val)+");
");
    }
    else
    {
      P[ip]:=[x,val];
      ip:=ip+1;
      textp:=concat(textp,"P["+(ip)+"]:=("+evalf(x)+","+evalf(val)+");
");
    }
   }
   else
   {
     if (etatc==1) then
     {
       etatc:=0;
       textp:=concat(textp,"

draw P[1] placer
for i:=2 upto ");
       textp:=concat(textp,""+ip+"");
       textp:=concat(textp,":
  ..P[i] placer
endfor
withcolor "+F[1]+";

");
     }
   }
}

if (etatc==1) then
{
  etatc:=0;
  textp:=concat(textp,"

draw P[1] placer
for i:=2 upto ");
textp:=concat(textp,""+ip+"");
textp:=concat(textp,":
  ..P[i] placer
endfor
withcolor "+F[1]+";

");
}

// dessin des extremites

if (size(F)==3) then
{
  B:=F[2];
  if (size(B)==3) then
  {
    if ((B[2]=="ff") or (B[2]=="fo")) then
    {
      tmin:=f(xtmin);
      if (abs(tmin)<0.00001) then
      {
        tmin:=0;
      }
      textp:=concat(textp,"dotlabel(btex etex,("+evalf(xtmin)+","+evalf(tmin)+")placer) withcolor  "+F[1]+";
");
    }
    if ((B[2]=="ff") or (B[2]=="of")) then
    {
      tmax:=f(xtmax);
      if (abs(tmax)<0.00001) then
      {
        tmax:=0;
      }
      textp:=concat(textp,"dotlabel(btex etex,("+evalf(xtmax)+","+evalf(tmax)+")placer) withcolor  "+F[1]+";
");
    }
  }
}

                        //  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                        //       % Affichage des termes de la suite



ui:=Su[2];
textu:=("label.bot(TEX(\" $"+Su[0]+"_"+Su[1]+"$ \"),("+ui+",0) placer) withcolor "+V[1]+";
");
Nb:=V[0];
if (size(V)==2) then
{
  for (j:=1;j<=Nb-1;j++)
  {
    vi:=evalf(f(ui));
    inds:=Su[1]+j;
    textu:=concat(textu,"draw ("+ui+",0) placer -- ("+ui+","+vi+") placer dashed evenly withcolor "+V[1]+";
draw ("+ui+","+vi+") placer -- ("+vi+","+vi+") placer dashed evenly withcolor "+V[1]+";
draw ("+vi+","+vi+") placer -- ("+vi+",0) placer dashed evenly withcolor "+V[1]+";
label.bot(TEX(\" $"+Su[0]+"_"+inds+"$ \"),("+vi+",0) placer) withcolor "+V[1]+";
");
    ui:=vi;
  }
}
else
{
  vi:=evalf(f(ui));
  textu:=concat(textu,"draw ("+ui+",0) placer -- ("+ui+","+vi+") placer dashed evenly withcolor "+V[1]+";
draw ("+ui+","+vi+") placer -- ("+vi+","+vi+") placer dashed evenly withcolor "+V[1]+";
");
  ui:=vi;
  for (j:=2;j<=Nb-1;j++)
  {
    vi:=evalf(f(ui));
    textu:=concat(textu,"draw ("+ui+","+ui+") placer -- ("+ui+","+vi+") placer dashed evenly withcolor "+V[1]+";
draw ("+ui+","+vi+") placer -- ("+vi+","+vi+") placer dashed evenly withcolor "+V[1]+";
");
    ui:=vi;
  }
}




                        //  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                        //       % Traitement des options

N:=size(T);
textt:=("%%%%%%%%%%%%%%%% Complements %%%%%%%%%%%%%%%%%%%%%%%%

");

texti:=("%%%%%%%%%%%%%%%% titres %%%%%%%%%%%%%%%%%%%%%%%%

");

if (N!=0) then
{
  for(j:=0;j<=N-1;j++)
  {
    V:=T[j];




////////////////////////////////////////////////////////////////////////////////////////////////////

    if (V[0]=="point-courbe") then
    {
      textt:=concat(textt,"%%%%%%%%%%%%%%%% Point sur courbe %%%%%%%%%%%%%%%%%%%%%%%%

");
      t:=V[1];
      val:=f(t);
      if (abs(val)<0.00001) then
      {
        val:=0;
      }
      textt:=concat(textt,"label."+V[3]+"(TEX(\" "+V[2]+" \"),("+t+","+evalf(val)+") placer) withcolor "+V[4]+";
");
      textt:=concat(textt,"draw("+t+","+evalf(val)+") placer shifted (-0.1cm,0)--("+t+","+evalf(val)+") placer shifted (0.1cm,0) withcolor "+V[4]+";
");
          textt:=concat(textt,"draw("+t+","+evalf(val)+") placer shifted (0,-0.1cm)--("+t+","+evalf(val)+") placer shifted (0,0.1cm) withcolor "+V[4]+";
");
      if (size(V)==6) then
      {
        if ((V[5,0]=="x") or (V[5,0]=="xy")) then
        {
          textt:=concat(textt,"draw("+t+",0) placer--("+t+","+evalf(val)+") placer dashed evenly withcolor  "+V[4]+";
");
          if (size(V[5])==1) then
          {
            if (val>0) then
            {
              textt:=concat(textt,"label.bot(TEX(\"$ "+latex(t)+" $\"),("+t+",0) placer) withcolor  "+V[4]+";
");
            }
            else
            {
              textt:=concat(textt,"label.top(TEX(\"$ "+latex(t)+" $\"),("+t+",0) placer) withcolor  "+V[4]+";
");
            }
          }
          else
          {
            if (val>0) then
            {
              textt:=concat(textt,"label.bot(TEX(\" "+V[5,1]+" \"),("+t+",0) placer) withcolor  "+V[4]+";
");
            }
            else
            {
              textt:=concat(textt,"label.top(TEX(\" "+V[5,1]+" \"),("+t+",0) placer) withcolor  "+V[4]+";
");
            }
          }
        }
        if ((V[5,0]=="y") or (V[5,0]=="xy")) then
        {
          textt:=concat(textt,"draw(0,"+evalf(val)+") placer--("+t+","+evalf(val)+") placer dashed evenly withcolor  "+V[4]+";
");
          if (size(V[5])==1) then
          {
            if (t>0) then
            {
              textt:=concat(textt,"label.lft(TEX(\"$ "+latex(evalf(val))+" $\"),(0,"+evalf(val)+") placer) withcolor  "+V[4]+";
");
            }
            else
            {
              textt:=concat(textt,"label.rt(TEX(\"$ "+latex(evalf(val))+" $\"),(0,"+evalf(val)+") placer) withcolor  "+V[4]+";
");
            }
          }
          else
          {
            if (t>0) then
            {
              textt:=concat(textt,"label.lft(TEX(\" "+V[5,2]+" \"),(0,"+evalf(val)+") placer) withcolor  "+V[4]+";
");
            }
            else
            {
              textt:=concat(textt,"label.rt(TEX(\" "+V[5,2]+" \"),(0,"+evalf(val)+") placer) withcolor  "+V[4]+";
");
            }

          }
        }
      }
    }





////////////////////////////////////////////////////////////////////////////////////////////////////

    if (V[0]=="point-libre") then
    {
      textt:=concat(textt,"%%%%%%%%%%%%%%%% Point libre %%%%%%%%%%%%%%%%%%%%%%%%

");
      xtmin:=evalf(V[1,0]);
      tmin:=evalf(V[1,1]);
      textt:=concat(textt,"label."+V[3]+"(TEX(\" "+V[2]+" \"),("+xtmin+","+tmin+") placer) withcolor "+V[4]+";
");
      textt:=concat(textt,"draw("+xtmin+","+tmin+") placer shifted (-0.1cm,0)--("+xtmin+","+tmin+") placer shifted (0.1cm,0) withcolor "+V[4]+";
");
      textt:=concat(textt,"draw("+xtmin+","+tmin+") placer shifted (0,-0.1cm)--("+xtmin+","+evalf(tmin)+") placer shifted (0,0.1cm) withcolor "+V[4]+";
");

      if (size(V)==6) then
      {
        if ((V[5,0]=="x") or (V[5,0]=="xy")) then
        {
          textt:=concat(textt,"draw("+xtmin+",0) placer--("+xtmin+","+tmin+") placer dashed evenly withcolor  "+V[4]+";
");

          if (size(V[5])==1) then
          {
            if (tmin>0) then
            {
              textt:=concat(textt,"label.bot(TEX(\"$ "+latex(V[1,0])+" $\"),("+xtmin+",0) placer) withcolor  "+V[4]+";
");
            }
            else
            {
              textt:=concat(textt,"label.top(TEX(\"$ "+latex(V[1,0])+" $\"),("+xtmin+",0) placer) withcolor  "+V[4]+";
");
            }
          }
          else
          {
            if (tmin>0) then
            {
              textt:=concat(textt,"label.bot(TEX(\" "+V[5,1]+" \"),("+xtmin+",0) placer) withcolor  "+V[4]+";
");
            }
            else
            {
              textt:=concat(textt,"label.top(TEX(\" "+V[5,1]+" \"),("+xtmin+",0) placer) withcolor  "+V[4]+";
");
            }
          }
        }
        if ((V[5,0]=="y") or (V[5,0]=="xy")) then
        {
          textt:=concat(textt,"draw(0,"+tmin+") placer--("+xtmin+","+tmin+") placer dashed evenly withcolor  "+V[4]+";
");
          if (size(V[5])==1) then
          {
            if (xtmin>0) then
            {
              textt:=concat(textt,"label.lft(TEX(\"$ "+latex(V[1,1])+" $\"),(0,"+tmin+") placer) withcolor  "+V[4]+";
");
            }
            else
            {
              textt:=concat(textt,"label.rt(TEX(\"$ "+latex(V[1,1])+" $\"),(0,"+tmin+") placer) withcolor  "+V[4]+";
");
            }
          }
          else
          {
            if (xtmin>0) then
            {
              textt:=concat(textt,"label.lft(TEX(\" "+V[5,2]+" \"),(0,"+tmin+") placer) withcolor  "+V[4]+";
");
            }
            else
            {
              textt:=concat(textt,"label.rt(TEX(\" "+V[5,2]+" \"),(0,"+tmin+") placer) withcolor  "+V[4]+";
");
            }

          }
        }
      }
    }





////////////////////////////////////////////////////////////////////////////////////////////////////

    if (V[0]=="texte-courbe") then
    {
      textt:=concat(textt,"%%%%%%%%%%%%%%%% Texte lie a la courbe %%%%%%%%%%%%%%%%%%%%%%%%

");
      t:=V[1];
      val:=f(t);
      if (abs(val)<0.00001) then
      {
        val:=0;
      }
      texts:=V[2];
      textt:=concat(textt,"label."+V[3]+"(TEX(\" \\colorbox\{white\}\{\\textcolor\{"+V[4]+"\}\{");
      textt:=concat(textt,texts);
      textt:=concat(textt,"\}\} \"),("+t+","+evalf(val)+") placer);
");
    }



////////////////////////////////////////////////////////////////////////////////////////////////////

    if (V[0]=="texte-libre") then
    {
      textt:=concat(textt,"%%%%%%%%%%%%%%%% Texte libre %%%%%%%%%%%%%%%%%%%%%%%%

");
      xtmin:=V[1,0];
      tmin:=V[1,1];
      texts:=V[2];
      textt:=concat(textt,"label."+V[3]+"(TEX(\" \\colorbox\{white\}\{\\textcolor\{"+V[4]+"\}\{");
      textt:=concat(textt,texts);
      textt:=concat(textt,"\}\} \"),("+xtmin+","+tmin+") placer);
");
    }


////////////////////////////////////////////////////////////////////////////////////////////////////

    if (V[0]=="titre-gauche") then
    {
      texti:=concat(texti,"%%%%%%%%%%%%%%%% Titre a gauche %%%%%%%%%%%%%%%%%%%%%%%%

");
      texti:=concat(texti,"titre:=1;
");
      texti:=concat(texti,"label.rt(TEX(\" "+V[1]+" \"),(xmin,ymax) placer shifted (0,0.7cm));
");
    }


////////////////////////////////////////////////////////////////////////////////////////////////////

    if (V[0]=="titre-droite") then
    {
      texti:=concat(texti,"%%%%%%%%%%%%%%%% Titre a droite %%%%%%%%%%%%%%%%%%%%%%%%

");
      texti:=concat(texti,"titre:=1;
");
      texti:=concat(texti,"label.lft(TEX(\" "+V[1]+" \"),(xmax,ymax) placer shifted (0,0.7cm));
");
    }



////////////////////////////////////////////////////////////////////////////////////////////////////

    if (V[0]=="titre-centre") then
    {
      texti:=concat(texti,"%%%%%%%%%%%%%%%% Titre centre %%%%%%%%%%%%%%%%%%%%%%%%

");
      texti:=concat(texti,"titre:=1;
");
      texti:=concat(texti,"label(TEX(\" "+V[1]+" \"),((xmin+xmax)/2,ymax) placer shifted (0,0.7cm));
");
    }





  }
}





                        //  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                        //       % Creation du fichier metapost

Dessin:="
input dlf\_couleurs.mp;
input dlf\_tex.mp;
input dlf\_repere.mp;


numeric xmin,xmax,ymin,ymax,dx,dy;
numeric carx,cary,gradx,grady;
xmin:="+xmin+";
xmax:="+xmax+";
ymin:="+ymin+";
ymax:="+ymax+";
dx:=1cm/"+ux+";
dy:=1cm/"+uy+";
carx:="+cx+";
cary:="+cy+";
gradx:="+gx+";
grady:="+gy+";

pair a,b,c,d;
path aire;


beginfig(0);


draw grillehori(xmin,xmax,ymin,ymax,dx,dy,grady) dashed evenly withcolor gris;
draw grilleverti(xmin,xmax,ymin,ymax,dx,dy,gradx) dashed evenly withcolor gris;

draw(xmin,ymin) placer--(xmin,ymax) placer --(xmax,ymax) placer --(xmax,ymin) placer --cycle withpen pencircle scaled 1bp withcolor gris;

draw(xmin,0) placer--(xmax,0) placer;
draw(0,ymin) placer--(0,ymax) placer;
label.llft(TEX(\"$O$\"),(0,0)placer);
label.bot(TEX(\"$\\vec{i}$\"),(0.5,0)placer);
drawarrow (0,0)placer--(1,0)placer;
label.lft(TEX(\"$\\vec{j}$\"),(0,0.5)placer);
drawarrow (0,0)placer--(0,1)placer;

% droite y=x

draw (xmin,xmin) placer -- (xmax,xmax) placer;

% affichage des points de la suite
"+textu+"

pair P[];

"+textp+"


"+textt+"

path limite;
limite:=(xmin*dx,ymin*dy)--(xmax*dx,ymin*dy)--(xmax*dx,ymax*dy)--(xmin*dx,ymax*dy)--cycle;
clip currentpicture to limite;

graduationstatx.bot(xmin,xmax,ymin,ymax,dx,dy,carx);
graduationstaty.lft(xmin,xmax,ymin,ymax,dx,dy,cary);

% titre
numeric titre;
titre:=0;

"+texti+"

if (titre=1):
  draw (xmin,ymax) placer shifted (0,0.1cm) --(xmax,ymax) placer shifted (0,0.1cm) withpen pencircle scaled 1bp withcolor gris;
  draw (xmin,ymax) placer shifted (0,1.3cm)--(xmax,ymax) placer shifted (0,1.3cm) withpen pencircle scaled 1bp withcolor gris;
fi;


endfig;
end
";
}:;
